/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2021/08/08
* Description        : Main program body.
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* SPDX-License-Identifier: Apache-2.0
*******************************************************************************/

/*
 *@Note
 PWṂ
 TIM1_CH1(PA8)
 ʾ TIM_CH1(PA8)  PWMģʽ1PWMģʽ2 £ PWM

*/

#include "debug.h"


void Tim2_Cnfg(void)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure={0};
    NVIC_InitTypeDef         NVIC_InitStructure={0};

    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2 , ENABLE);
		
    TIM_DeInit(TIM2);
    TIM_TimeBaseStructure.TIM_Period=1000;                         // ԶװؼĴڵֵ(ֵ)//
    //ۼ TIM_PeriodƵʺһ»ж//
    TIM_TimeBaseStructure.TIM_Prescaler= (144 - 1);                // ʱԤƵ 72M/72 //
    TIM_TimeBaseStructure.TIM_ClockDivision=TIM_CKD_DIV1;          // Ƶ //
    TIM_TimeBaseStructure.TIM_CounterMode=TIM_CounterMode_Up;      // ϼģʽ //
    TIM_TimeBaseInit(TIM2, &TIM_TimeBaseStructure);

    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);

    TIM_ClearFlag(TIM2, TIM_FLAG_Update);                          // жϱ־ //
    TIM_ITConfig(TIM2,TIM_IT_Update,ENABLE);
		TIM_ARRPreloadConfig( TIM2, ENABLE );
    TIM_Cmd(TIM2, ENABLE); //TIM4ʹ
		
}

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main( void )
{
    USART_Printf_Init( 115200 );
    printf( "SystemClk:%d\r\n", SystemCoreClock );

    Tim2_Cnfg();

    while( 1 );
}


void TIM2_IRQHandler(void)
{
    if ( TIM_GetITStatus(TIM2 , TIM_IT_Update) != RESET )
    {
        TIM_ClearITPendingBit(TIM2 , TIM_IT_Update);
        printf("Enter TIM2 interrupt\n");
    }
}
